@echo off
goto skiprems
rem this file is well documented, but it will take OS/2 a long time to
rem process all the commnets.  Therefore, all the code has been copied
rem to the end without comments, and the above goto skips to them.


rem REFLOW.CMD by Dovid Gross.  v1.1, 12/10/91.  "rem" lines deletable.

rem This file only runs under OS/2.  you may however use the DOS version
rem of PKUNZIP if you run OS/2 2.0.  see READ.ME, READSBBS.DOC, and the
rem comments in this file for full information.

rem Use READBBS to append new mail captured as a zip file to old mail,
rem and to then read all new mail.  assumes that the directory where the
rem captured mail files are located is the root of the current drive,
rem that the file have been downloaded in ZIP format, that you are using
rem OS/2 and the OS/2-specific version of PKUNZIP (known as PKUNZIP2; if
rem you use the family-mode version under either DOS or OS/2, it would
rem PKUNZIPF; if you use plain-jane DOS, it would be plain-jane
rem PKUNZIP).  also assumes that your config file is READBBS.CFG, that
rem your mail/index files are READBBS.TXT/READBBS.IDX, that both these
rem files are located in the current directory, and that the READBBS.CMD
rem file is also in the current directory or is in your path

if "%transfer_dir%" == "" set transfer_dir=h:\rexxterm\
rem the directory where your communications program does file transfers
rem (upload/download).  change to proper location if you do transfers to
rem somewhere else; include a backslash at the end.  we assume that your
rem mail capture file (MAILxx.ZIP) will be located in this location, and
rem that replies files from readbbs will beplaced here for uploading.
rem there are two other variables, newmail_dir and reply_dir, below that
rem by default are set to whatever value is used here for transfer_dir;
rem if the two values are different, you will have to maintain them
rem below, separately.

if "%mail_file%"=="" set mail_file=readbbs.txt
rem change to name of the mail text file you use

if "%readbbs_dir%" == "" set readbbs_dir=
rem place a path if READBBS.CMD not current directory and not in path;
rem include a backslash at the end

if "%pk_dir%" == "" set pk_dir=
rem place path of pkunzip program file here if not in path; include a
rem backslash at the end

if "%unzip_name%" == "" set unzip_name=pkunzip2
rem change to pkunzipf if you use family mode; if using DOS version,
rem change to PKUNZIP,  PKUNZIP2 is OS/2-specific version.

if "%newmail_dir%" == "" set newmail_dir=%transfer_dir%
rem we assume new mail is in the file transfer (upload/download)
rem directory of your communications program; we set "transfer_dir" to
rem this directory above, so you can either change that value (so it
rem affects newmail_dir AND reply_dir below), or you can just change it
rem here (and you will have to maintain newmail_dir and reply_dir
rem separately).  include a backslash at the end of the directory name.

if "%reply_dir%" == "" set reply_dir=%transfer_dir%
rem we assume that you will place reply files, which must be uploaded,
rem in the same directory as the download directory where your capture
rem mail*.zip were placed.  normally, READBBS places reply files in the
rem current directory; to change this to another directory, you must set
rem up user variable "drive" and/or "path" in your config file (see
rem READBBS.DOC for more information on user variables, drive and path
rem in particular).  if you don't have drive/and or path set up in your
rem config file, then change above line to "set reply_dir=" or if you
rem choose another directory entirely, you can either change variable
rem transfer_dir above (to affect both newmail_dir and reply_dir), or
rem you can change the value here (if you use different directories for
rem new mail capture files and reply files).  include backslash at end.

rem the mail file is named mail##.txt (we don't know what ## will be, it
rem changes with each capture), located in a zip archive (mail##.zip).
rem in order to use the specific mail file, we rename it to mail.zip/txt
rem using the wildcard feature of the OS.  we must get rid of old copies
rem or renames do not work.

if exist mail.zip rename mail.zip old_mail.zip
if exist mail.txt rename mail.txt old_mail.txt
if exist mail.zip (echo Old ZIP remains?  Abort! & pause & goto die)
if exist mail.txt (echo Old TXT remains?  Abort! & pause & goto die)
rem put old files on hold and check we were succesful

if not exist %newmail_dir%mail*.zip (echo No capture?  Abort! & pause & goto die)
rem no new capture file to append!

if not exist mail*.zip move %newmail_dir%mail*.zip
rem put the zipped mail file in the current directory instead of the
rem download directory.  test is in case %newmail_dir% is current dir

if not exist mail*.zip (echo No ZIP?  Abort! & pause & goto die)
rem check for successful move

rename mail*.zip mail.zip
rem the zip file is captured as MAILxx.zip; in order to use a specific
rem name, we rename it.  a lot of the work above involed making sure
rem that there is only one mail*.zip file present to be processed (or
rem else, rename would try to rename multiple files to the same name!)

if not exist mail.zip (echo Lost ZIP?  Abort! & pause & goto die)
rem test for successful rename of zip

if exist old_mail.zip del old_mail.zip
rem we have the new one, purge the old from hold

%pk_dir%%unzip_name% mail.zip
rem get the captured text file out of the captured zipped file

if not exist mail*.txt (echo No TXT?  Abort! & pause & goto die)
rem test that we got a mail##.txt

rename mail*.txt mail.txt
rem same business as rename of the zip file

if not exist mail.txt (echo Lost TXT?  Abort! & pause & goto die)
rem test that we now have the text file before we kill the zip file

if exist old_mail.txt del old_mail.txt
rem same business again -- we have the new one, purge the old from hold

del mail.zip
rem kill the zip file so it isn't here next time (it would be held off
rem anyway by the first if exist mail*.zip, but insurance is good)

echo Loading READBBS for merge and read...
call %readbbs_dir%readbbs %mail_file% + mail.txt
rem call the READBBS program to read our mail file, merging it with the
rem just downloaded/moved/renamed/unzipped/renamed mail update file
rem NOTE: we use the CALL command so READBBS will come back here when it
rem is through; otherwise, the rest of the lines would be ignored

echo Shutting down new mail; one moment...

: for %%i in (%reply_dir%rep*.??) do dev\reflow %%i
rem above line would "reflow" any replies so that lines are 72-columns
rem or less.  it is commented out because it should be unnecessary,
rem since READBBS automatically flows the reply when it is created, and
rem after each time you edit it.  however,  if you went "behind
rem READBBS's back" (e.g., edited a reply in another session, or, when
rem editing one reply, called up another reply in your editor), then
rem the reply might need to be reflowed.  remove the colon at the
rem beginning of the line if you do such things and want to play it
rem safe!

rem the set command below are to clean up after ourselves
set transfer_dir=
set mail_file=
set readbbs_dir=
set pk_dir=
set unzip_name=
set newmail_dir=
set reply_dir=

goto end
:skiprems
if "%transfer_dir%" == "" set transfer_dir=h:\rexxterm\
if "%mail_file%"=="" set mail_file=readbbs.txt
if "%readbbs_dir%" == "" set readbbs_dir=
if "%pk_dir%" == "" set pk_dir=
if "%unzip_name%" == "" set unzip_name=pkunzip2
if "%newmail_dir%" == "" set newmail_dir=%transfer_dir%
if "%reply_dir%" == "" set reply_dir=%transfer_dir%
if exist mail.zip rename mail.zip old_mail.zip
if exist mail.txt rename mail.txt old_mail.txt
if exist mail.zip (echo Old ZIP remains?  Abort! & pause & goto die)
if exist mail.txt (echo Old TXT remains?  Abort! & pause & goto die)
if not exist %newmail_dir%mail*.zip (echo No capture?  Abort! & pause & goto die)
if not exist mail*.zip move %newmail_dir%mail*.zip
if not exist mail*.zip (echo No ZIP?  Abort! & pause & goto die)
rename mail*.zip mail.zip
if not exist mail.zip (echo Lost ZIP?  Abort! & pause & goto die)
if exist old_mail.zip del old_mail.zip
%pk_dir%%unzip_name% mail.zip
if not exist mail*.txt (echo No TXT?  Abort! & pause & goto die)
rename mail*.txt mail.txt
if not exist mail.txt (echo Lost TXT?  Abort! & pause & goto die)
if exist old_mail.txt del old_mail.txt
del mail.zip
echo Loading READBBS for merge and read...
call %readbbs_dir%readbbs %mail_file% + mail.txt
echo Shutting down new mail; one moment...
: for %%i in (%reply_dir%rep*.??) do dev\reflow %%i
set transfer_dir=
set mail_file=
set readbbs_dir=
set pk_dir=
set unzip_name=
set newmail_dir=
set reply_dir=
:end
